"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Fs = require("fs");
const languageMap = require('language-map');
const lang = require('language-classifier');
;
const DefaultDetectorOptions = {};
const DefaultDatectedFileInfo = {
    fileType: '',
    fileSize: 0,
    totalLine: 0,
    lines: {}
};
class LanguageDetector {
    constructor(options) {
        return new LanguageDetector();
    }
    ;
    static getLanguageExtensionMap() {
        let extensions = {};
        Object.keys(languageMap).map(language => {
            let languageMode = languageMap[language], languageExtensions = languageMode && languageMode.extensions || [];
            languageExtensions.map((extension) => {
                extensions[extension.toLowerCase()] = language.toLowerCase();
            });
        });
        return extensions;
    }
    static getFileType(filePath) {
        let fileExtension = '.' + filePath.split('.').pop();
        if (!Object.keys(this.extensionMap).length) {
            this.extensionMap = this.getLanguageExtensionMap();
        }
        return fileExtension ? (this.extensionMap[fileExtension] || '') : '';
    }
    static classify(codeSnippet) {
        return codeSnippet ? lang(codeSnippet) : '';
    }
    static getFileInfo(filePath, options) {
        let fileInfo = Object.assign({}, DefaultDatectedFileInfo);
        let fileStat;
        let fileData;
        let lines;
        try {
            fileStat = Fs.statSync(filePath);
            fileData = Fs.readFileSync(filePath, 'utf-8');
        }
        catch (err) {
            throw new Error('read file failed.');
        }
        lines = fileData.split(/\n/);
        fileInfo.fileSize = fileStat && fileStat.size || 0;
        fileInfo.totalLine = lines && lines.length || 0;
        fileInfo.fileType = this.getFileType(filePath);
        lines.map((line, index) => {
            let languageType = this.classify(line);
            if (!fileInfo.lines[languageType]) {
                fileInfo.lines[languageType] = 1;
            }
            else {
                fileInfo.lines[languageType]++;
            }
        });
        return fileInfo;
    }
}
LanguageDetector.extensionMap = {};
exports.LanguageDetector = LanguageDetector;
;
//# sourceMappingURL=index.js.map